/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

// AttestationApplyConfiguration represents an declarative configuration of the Attestation type for use
// with apply.
type AttestationApplyConfiguration struct {
	Name          *string                              `json:"name,omitempty"`
	PredicateType *string                              `json:"predicateType,omitempty"`
	Type          *string                              `json:"type,omitempty"`
	Attestors     []AttestorSetApplyConfiguration      `json:"attestors,omitempty"`
	Conditions    []AnyAllConditionsApplyConfiguration `json:"conditions,omitempty"`
}

// AttestationApplyConfiguration constructs an declarative configuration of the Attestation type for use with
// apply.
func Attestation() *AttestationApplyConfiguration {
	return &AttestationApplyConfiguration{}
}

// WithName sets the Name field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Name field is set to the value of the last call.
func (b *AttestationApplyConfiguration) WithName(value string) *AttestationApplyConfiguration {
	b.Name = &value
	return b
}

// WithPredicateType sets the PredicateType field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the PredicateType field is set to the value of the last call.
func (b *AttestationApplyConfiguration) WithPredicateType(value string) *AttestationApplyConfiguration {
	b.PredicateType = &value
	return b
}

// WithType sets the Type field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Type field is set to the value of the last call.
func (b *AttestationApplyConfiguration) WithType(value string) *AttestationApplyConfiguration {
	b.Type = &value
	return b
}

// WithAttestors adds the given value to the Attestors field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Attestors field.
func (b *AttestationApplyConfiguration) WithAttestors(values ...*AttestorSetApplyConfiguration) *AttestationApplyConfiguration {
	for i := range values {
		if values[i] == nil {
			panic("nil value passed to WithAttestors")
		}
		b.Attestors = append(b.Attestors, *values[i])
	}
	return b
}

// WithConditions adds the given value to the Conditions field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Conditions field.
func (b *AttestationApplyConfiguration) WithConditions(values ...*AnyAllConditionsApplyConfiguration) *AttestationApplyConfiguration {
	for i := range values {
		if values[i] == nil {
			panic("nil value passed to WithConditions")
		}
		b.Conditions = append(b.Conditions, *values[i])
	}
	return b
}
