/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

// ServiceCallApplyConfiguration represents an declarative configuration of the ServiceCall type for use
// with apply.
type ServiceCallApplyConfiguration struct {
	URL      *string                        `json:"url,omitempty"`
	Headers  []HTTPHeaderApplyConfiguration `json:"headers,omitempty"`
	CABundle *string                        `json:"caBundle,omitempty"`
}

// ServiceCallApplyConfiguration constructs an declarative configuration of the ServiceCall type for use with
// apply.
func ServiceCall() *ServiceCallApplyConfiguration {
	return &ServiceCallApplyConfiguration{}
}

// WithURL sets the URL field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the URL field is set to the value of the last call.
func (b *ServiceCallApplyConfiguration) WithURL(value string) *ServiceCallApplyConfiguration {
	b.URL = &value
	return b
}

// WithHeaders adds the given value to the Headers field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Headers field.
func (b *ServiceCallApplyConfiguration) WithHeaders(values ...*HTTPHeaderApplyConfiguration) *ServiceCallApplyConfiguration {
	for i := range values {
		if values[i] == nil {
			panic("nil value passed to WithHeaders")
		}
		b.Headers = append(b.Headers, *values[i])
	}
	return b
}

// WithCABundle sets the CABundle field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the CABundle field is set to the value of the last call.
func (b *ServiceCallApplyConfiguration) WithCABundle(value string) *ServiceCallApplyConfiguration {
	b.CABundle = &value
	return b
}
